#include <stdio.h>
#include <stdlib.h>

extern char *yytext;
extern int yylex();

char state = 'h';

int yyinput(char *buf, size_t max_size)
{
    int count;
    static int mylineno = 0;

    if (fgets(buf, max_size, stdin) == NULL)
	return 0;

    count = strlen(buf);

    fprintf(stdout, "inp: %2d %c %2d %s", ++mylineno,
	    state, count, buf);

    return count;
}

void got_emptyline(void)
{
    fprintf(stdout, "fcn:         %s\n", "empty line");
    state = 'b';
}

int main(int argc, char **argv)
{
    int t;
    while ((t = yylex()) > 0) {
	if (t == 1)
	    state = 'h';
	fprintf(stdout, "tok: %2d      %s\n", t, yytext);
    }

    return 0;
}
